// src/ConfirmModal.tsx
import { useState } from "react";
import { Button, Dialog, DialogActions, DialogContent, DialogContentText, DialogTitle, TextField } from "@mui/material";
import { jsx, jsxs } from "react/jsx-runtime";
var ConfirmModal = (props) => {
  const { close, onConfirm, className, toType, header, description, open, maxWidth = "xs" } = props;
  const [inputValue, setInputValue] = useState("");
  return /* @__PURE__ */ jsxs(
    Dialog,
    {
      className: className || "",
      open,
      onClose: close,
      maxWidth,
      PaperProps: {
        component: "form",
        onSubmit: (event) => {
          event.preventDefault();
          onConfirm();
          close();
        }
      },
      children: [
        /* @__PURE__ */ jsx(DialogTitle, { children: header }),
        /* @__PURE__ */ jsxs(DialogContent, { children: [
          /* @__PURE__ */ jsx(DialogContentText, { children: description }),
          /* @__PURE__ */ jsxs(DialogContentText, { children: [
            "Type '",
            toType,
            "' below to continue"
          ] }),
          /* @__PURE__ */ jsx(
            TextField,
            {
              value: inputValue,
              onChange: (e) => setInputValue(e.target.value),
              autoFocus: true,
              required: true,
              name: "confirmation-text",
              id: "confirmation-text",
              label: toType,
              type: "text"
            }
          )
        ] }),
        /* @__PURE__ */ jsxs(DialogActions, { children: [
          /* @__PURE__ */ jsx(Button, { onClick: close, children: "Cancel" }),
          /* @__PURE__ */ jsx(Button, { color: "secondary", type: "submit", variant: "contained", disabled: inputValue !== toType, children: "Confirm" })
        ] })
      ]
    }
  );
};

export {
  ConfirmModal
};
//# sourceMappingURL=chunk-CD4PMOGZ.js.map