"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.js
var src_exports = {};
__export(src_exports, {
  Tracking: () => tracking_default,
  attributeDuplicateFilter: () => attributeDuplicateFilter,
  blobToString: () => blobToString,
  byteArrayToString: () => byteArrayToString,
  canAccess: () => canAccess,
  clearAllRetryTimers: () => clearAllRetryTimers,
  clearRetryTimer: () => clearRetryTimer,
  commonProcessor: () => commonProcessor,
  createDownload: () => createDownload,
  createFileDownload: () => createFileDownload,
  customSort: () => customSort,
  dateRangeToUnix: () => dateRangeToUnix,
  deepCompare: () => deepCompare,
  defaultProcessors: () => defaultProcessors,
  detectOsIdentifier: () => detectOsIdentifier,
  duplicateFilter: () => duplicateFilter,
  extractErrorMessage: () => extractErrorMessage,
  extractSoftware: () => extractSoftware,
  extractSoftwareItem: () => extractSoftwareItem,
  formatAuditlogs: () => formatAuditlogs,
  formatDeployments: () => formatDeployments,
  formatDeviceSearch: () => formatDeviceSearch,
  formatPageState: () => formatPageState,
  formatReleases: () => formatReleases,
  formatTenants: () => formatTenants,
  formatTime: () => formatTime,
  fullyDecodeURI: () => fullyDecodeURI,
  generateDeploymentsPath: () => generateDeploymentsPath,
  generateDevicePath: () => generateDevicePath,
  generateReleasesPath: () => generateReleasesPath,
  generateTenantPath: () => generateTenantPath,
  generateTenantPathById: () => generateTenantPathById,
  getDebConfigurationCode: () => getDebConfigurationCode,
  getDemoDeviceAddress: () => getDemoDeviceAddress,
  getFormattedSize: () => getFormattedSize,
  getISOStringBoundaries: () => getISOStringBoundaries,
  getPhaseDeviceCount: () => getPhaseDeviceCount,
  getRemainderPercent: () => getRemainderPercent,
  getSnackbarMessage: () => getSnackbarMessage,
  isEmpty: () => isEmpty,
  parseAuditlogsQuery: () => parseAuditlogsQuery,
  parseDateParams: () => parseDateParams,
  parseDeploymentsQuery: () => parseDeploymentsQuery,
  parseDeviceQuery: () => parseDeviceQuery,
  parseReleasesQuery: () => parseReleasesQuery,
  parseTenantsQuery: () => parseTenantsQuery,
  preformatWithRequestID: () => preformatWithRequestID,
  setRetryTimer: () => setRetryTimer,
  standardizePhases: () => standardizePhases,
  startTimeSort: () => startTimeSort,
  stringToBoolean: () => stringToBoolean,
  toggle: () => toggle,
  unionizeStrings: () => unionizeStrings,
  useDebounce: () => useDebounce,
  useLocationParams: () => useLocationParams,
  useSession: () => useSession,
  useWindowSize: () => useWindowSize,
  validatePhases: () => validatePhases,
  versionCompare: () => versionCompare,
  yes: () => yes
});
module.exports = __toCommonJS(src_exports);

// src/debouncehook.js
var import_react = require("react");
var useDebounce = (value, delay) => {
  const [debouncedValue, setDebouncedValue] = (0, import_react.useState)(value);
  (0, import_react.useEffect)(() => {
    const timer = setTimeout(() => {
      setDebouncedValue(value);
    }, delay);
    return () => clearTimeout(timer);
  }, [value, delay]);
  return debouncedValue;
};

// src/helpers.js
var import_dayjs = __toESM(require("dayjs"), 1);
var import_utc = __toESM(require("dayjs/plugin/utc.js"), 1);
var import_pluralize = __toESM(require("pluralize"), 1);
var import_universal_cookie = __toESM(require("universal-cookie"), 1);
import_dayjs.default.extend(import_utc.default);
var isEncoded = (uri) => {
  uri = uri || "";
  return uri !== decodeURIComponent(uri);
};
var fullyDecodeURI = (uri) => {
  while (isEncoded(uri)) {
    uri = decodeURIComponent(uri);
  }
  return uri;
};
var isEmpty = (obj) => {
  for (const _ in obj) {
    return false;
  }
  return true;
};
var yes = () => true;
var canAccess = yes;
var versionCompare = (v1, v2) => {
  const partsV1 = `${v1}`.split(".");
  const partsV2 = `${v2}`.split(".");
  for (let index = 0; index < partsV1.length; index++) {
    const numberV1 = partsV1[index];
    const numberV2 = partsV2[index];
    if (numberV1 > numberV2) {
      return 1;
    }
    if (numberV2 > numberV1) {
      return -1;
    }
  }
  return 0;
};
function deepCompare() {
  var i, l, leftChain, rightChain;
  function compare2Objects(x, y) {
    var p;
    if (isNaN(x) && isNaN(y) && typeof x === "number" && typeof y === "number") {
      return true;
    }
    if (x === y) {
      return true;
    }
    if (typeof x === "function" && typeof y === "function" || x instanceof Date && y instanceof Date || x instanceof RegExp && y instanceof RegExp || x instanceof String && y instanceof String || x instanceof Number && y instanceof Number) {
      return x.toString() === y.toString();
    }
    if (!(x instanceof Object && y instanceof Object)) {
      return false;
    }
    if (x.isPrototypeOf(y) || y.isPrototypeOf(x)) {
      return false;
    }
    if (x.constructor !== y.constructor) {
      return false;
    }
    if (x.prototype !== y.prototype) {
      return false;
    }
    if (leftChain.indexOf(x) > -1 || rightChain.indexOf(y) > -1) {
      return false;
    }
    for (p in y) {
      if (y.hasOwnProperty(p) !== x.hasOwnProperty(p) || typeof y[p] !== typeof x[p]) {
        return false;
      }
    }
    for (p in x) {
      if (y.hasOwnProperty(p) !== x.hasOwnProperty(p) || typeof y[p] !== typeof x[p]) {
        return false;
      }
      switch (typeof x[p]) {
        case "object":
        case "function":
          leftChain.push(x);
          rightChain.push(y);
          if (!compare2Objects(x[p], y[p])) {
            return false;
          }
          leftChain.pop();
          rightChain.pop();
          break;
        default:
          if (x[p] !== y[p]) {
            return false;
          }
          break;
      }
    }
    return true;
  }
  if (arguments.length < 1) {
    return true;
  }
  for (i = 1, l = arguments.length; i < l; i++) {
    leftChain = [];
    rightChain = [];
    if (!compare2Objects(arguments[0], arguments[i])) {
      return false;
    }
  }
  return true;
}
var stringToBoolean = (content) => {
  if (!content) {
    return false;
  }
  const string = content + "";
  switch (string.trim().toLowerCase()) {
    case "true":
    case "yes":
    case "1":
      return true;
    case "false":
    case "no":
    case "0":
    case null:
      return false;
    default:
      return Boolean(string);
  }
};
var toggle = (current) => !current;
var formatTime = (date) => {
  if (date && Object.prototype.toString.call(date) === "[object Date]" && !isNaN(date)) {
    return date.toISOString().slice(0, -1);
  } else if (date) {
    return date.replace(" ", "T").replace(/ /g, "").replace("UTC", "");
  }
};
var customSort = (direction, field) => (a, b) => {
  if (typeof a[field] === "string") {
    const result = a[field].localeCompare(b[field], { sensitivity: "case" });
    return direction ? result * -1 : result;
  }
  if (a[field] > b[field]) return direction ? -1 : 1;
  if (a[field] < b[field]) return direction ? 1 : -1;
  return 0;
};
var duplicateFilter = (item, index, array) => array.indexOf(item) == index;
var attributeDuplicateFilter = (filterableArray, attributeName = "key") => filterableArray.filter(
  (item, index, array) => array.findIndex((filter) => filter[attributeName] === item[attributeName] && filter.scope === item.scope) == index
);
var unionizeStrings = (someStrings, someOtherStrings) => {
  const startingPoint = new Set(someStrings.filter((item) => item.length));
  const uniqueStrings = someOtherStrings.length ? someOtherStrings.reduce((accu, item) => {
    if (item.trim().length) {
      accu.add(item.trim());
    }
    return accu;
  }, startingPoint) : startingPoint;
  return [...uniqueStrings];
};
var getFormattedSize = (bytes) => {
  const suffixes = ["Bytes", "KB", "MB", "GB"];
  const i = Math.floor(Math.log(bytes) / Math.log(1024));
  if (!bytes) {
    return "0 Bytes";
  }
  return `${(bytes / Math.pow(1024, i)).toFixed(2)} ${suffixes[i]}`;
};
var collectAddressesFrom = (devices) => devices.reduce((collector, { attributes = {} }) => {
  const ips = Object.entries(attributes).reduce((accu, [name, value]) => {
    if (name.startsWith("ipv4")) {
      if (Array.isArray(value)) {
        const texts = value.map((text) => text.slice(0, text.indexOf("/")));
        accu.push(...texts);
      } else {
        const text = value.slice(0, value.indexOf("/"));
        accu.push(text);
      }
    }
    return accu;
  }, []);
  collector.push(...ips);
  return collector;
}, []);
var getDemoDeviceAddress = (devices, onboardingApproach) => {
  const defaultVitualizedIp = "10.0.2.15";
  const addresses = collectAddressesFrom(devices);
  const address = addresses.reduce((accu, item) => {
    if (accu && item === defaultVitualizedIp) {
      return accu;
    }
    return item;
  }, null);
  if (!address || onboardingApproach === "virtual" && (navigator.appVersion.indexOf("Win") != -1 || navigator.appVersion.indexOf("Mac") != -1)) {
    return "localhost";
  }
  return address;
};
var detectOsIdentifier = () => {
  if (navigator.appVersion.indexOf("Win") != -1) return "Windows";
  if (navigator.appVersion.indexOf("Mac") != -1) return "MacOs";
  if (navigator.appVersion.indexOf("X11") != -1) return "Unix";
  return "Linux";
};
var getRemainderPercent = (phases) => {
  phases[phases.length - 1].batch_size = null;
  return phases.reduce((accu, phase) => phase.batch_size ? accu - phase.batch_size : accu, 100);
};
var validatePhases = (phases, deploymentDeviceCount, hasFilter) => {
  if (!phases?.length) {
    return true;
  }
  const remainder = getRemainderPercent(phases);
  return phases.reduce((accu, phase) => {
    if (!accu) {
      return accu;
    }
    const deviceCount = Math.floor(deploymentDeviceCount / 100 * (phase.batch_size || remainder));
    return deviceCount >= 1 || hasFilter;
  }, true);
};
var getPhaseDeviceCount = (numberDevices = 1, batchSize, remainder, isLastPhase) => isLastPhase ? Math.ceil(numberDevices / 100 * (batchSize || remainder)) : Math.floor(numberDevices / 100 * (batchSize || remainder));
var startTimeSort = (a, b) => (b.created > a.created) - (b.created < a.created);
var standardizePhases = (phases) => phases.map((phase, index) => {
  let standardizedPhase = { batch_size: phase.batch_size, start_ts: index };
  if (phase.delay) {
    standardizedPhase.delay = phase.delay;
    standardizedPhase.delayUnit = phase.delayUnit || "hours";
  }
  if (index === 0) {
    delete standardizedPhase.start_ts;
  }
  return standardizedPhase;
});
var getInstallScriptArgs = ({ isHosted, isPreRelease, hasMonitor }) => {
  let installScriptArgs = "--demo";
  installScriptArgs = isPreRelease ? `${installScriptArgs} -c experimental` : installScriptArgs;
  installScriptArgs = isHosted && hasMonitor ? `${installScriptArgs} --commercial` : installScriptArgs;
  installScriptArgs = isHosted ? `${installScriptArgs} --jwt-token $JWT_TOKEN` : installScriptArgs;
  return installScriptArgs;
};
var getSetupArgs = ({ deviceType = "generic-armv6", ipAddress, isDemoMode, tenantToken, isOnboarding }) => {
  let menderSetupArgs = `--quiet --device-type "${deviceType}"`;
  menderSetupArgs = tenantToken ? `${menderSetupArgs} --tenant-token $TENANT_TOKEN` : menderSetupArgs;
  menderSetupArgs = isDemoMode || isOnboarding ? `${menderSetupArgs} --demo` : `${menderSetupArgs} --retry-poll 300 --update-poll 1800 --inventory-poll 28800`;
  if (isDemoMode) {
    menderSetupArgs = `${menderSetupArgs}${ipAddress ? ` --server-ip ${ipAddress}` : ""}`;
  } else {
    menderSetupArgs = `${menderSetupArgs} --server-url https://${window.location.hostname} --server-cert=""`;
  }
  return menderSetupArgs;
};
var installComponents = "--force-mender-client4";
var getDebConfigurationCode = (props) => {
  const { tenantToken, token, isPreRelease } = props;
  const envVars = tenantToken ? `JWT_TOKEN="${token}"
TENANT_TOKEN="${tenantToken}"
` : "";
  const installScriptArgs = getInstallScriptArgs(props);
  const scriptUrl = isPreRelease ? "https://get.mender.io/staging" : "https://get.mender.io";
  const menderSetupArgs = getSetupArgs(props);
  return `${envVars}wget -O- ${scriptUrl} | sudo bash -s -- ${installScriptArgs} ${installComponents} -- ${menderSetupArgs}`;
};
var getSnackbarMessage = (skipped, done) => {
  import_pluralize.default.addIrregularRule("its", "their");
  const skipText = skipped ? `${skipped} ${(0, import_pluralize.default)("devices", skipped)} ${(0, import_pluralize.default)("have", skipped)} more than one pending authset. Expand ${(0, import_pluralize.default)(
    "this",
    skipped
  )} ${(0, import_pluralize.default)("device", skipped)} to individually adjust ${(0, import_pluralize.default)("their", skipped)} authorization status. ` : "";
  const doneText = done ? `${done} ${(0, import_pluralize.default)("device", done)} ${(0, import_pluralize.default)("was", done)} updated successfully. ` : "";
  return `${doneText}${skipText}`;
};
var extractSoftware = (attributes = {}) => {
  const softwareKeys = Object.keys(attributes).reduce((accu, item) => {
    if (item.endsWith(".version")) {
      accu.push(item.substring(0, item.lastIndexOf(".")));
    }
    return accu;
  }, []);
  return Object.entries(attributes).reduce(
    (accu, item) => {
      if (softwareKeys.some((key) => item[0].startsWith(key))) {
        accu.software.push(item);
      } else {
        accu.nonSoftware.push(item);
      }
      return accu;
    },
    { software: [], nonSoftware: [] }
  );
};
var extractSoftwareItem = (artifactProvides = {}) => {
  const { software } = extractSoftware(artifactProvides);
  return software.reduce((accu, item) => {
    const infoItems = item[0].split(".");
    if (infoItems[infoItems.length - 1] !== "version") {
      return accu;
    }
    accu.push({
      key: infoItems[0],
      name: infoItems.slice(1, infoItems.length - 1).join("."),
      version: item[1],
      nestingLevel: infoItems.length
    });
    return accu;
  }, []).sort((a, b) => a.nestingLevel - b.nestingLevel).reduce((accu, item) => accu ?? item, void 0);
};
var cookies = new import_universal_cookie.default();
var createDownload = (target, filename, token) => {
  let link = document.createElement("a");
  link.setAttribute("href", target);
  link.setAttribute("download", filename);
  link.style.display = "none";
  document.body.appendChild(link);
  cookies.set("JWT", token, {
    path: "/",
    secure: true,
    sameSite: "strict",
    maxAge: 5
  });
  link.click();
  document.body.removeChild(link);
};
var createFileDownload = (content, filename, token) => createDownload("data:text/plain;charset=utf-8," + encodeURIComponent(content), filename, token);
var getISOStringBoundaries = (currentDate) => {
  const date = [currentDate.getUTCFullYear(), `0${currentDate.getUTCMonth() + 1}`.slice(-2), `0${currentDate.getUTCDate()}`.slice(-2)].join("-");
  return { start: `${date}T00:00:00.000`, end: `${date}T23:59:59.999` };
};
var extractErrorMessage = (err, fallback = "") => err.response?.data?.error?.message || err.response?.data?.error || err.error || err.message || fallback;
var preformatWithRequestID = (res, failMsg) => {
  if (failMsg.length > 100) failMsg = `${failMsg.substring(0, 220)}...`;
  try {
    if (res?.data && Object.keys(res.data).includes("request_id")) {
      let shortRequestUUID = res.data["request_id"].substring(0, 8);
      return `${failMsg} [Request ID: ${shortRequestUUID}]`;
    }
  } catch (e) {
    console.log("failed to extract request id:", e);
  }
  return failMsg;
};
var dateRangeToUnix = (startDate = null, endDate = null) => {
  const start = (0, import_dayjs.default)(startDate);
  const end = (0, import_dayjs.default)(endDate);
  let unixRange = { start: null, end: null };
  if (start.isValid()) {
    unixRange.start = start.utc().startOf("day").unix();
  }
  if (end.isValid()) {
    unixRange.end = end.utc().endOf("day").unix();
  }
  return unixRange;
};

// src/liststatehook.js
var import_react2 = require("react");
var import_react_router_dom = require("react-router-dom");

// src/locationutils.js
var import_constants = require("@northern.tech/store/constants");
var SEPARATOR = ":";
var defaultSelector = (result) => result[0];
var commonFields = {
  ...Object.keys(import_constants.DEVICE_LIST_DEFAULTS).reduce((accu, key) => ({ ...accu, [key]: { parse: Number, select: defaultSelector, target: key } }), {}),
  id: { parse: String, select: (i) => i, target: "id" },
  issues: { parse: void 0, select: defaultSelector, target: "selectedIssues" },
  open: { parse: Boolean, select: defaultSelector, target: "open" }
};
var scopes = {
  identity: { delimiter: "identity", filters: [] },
  inventory: { delimiter: "inventory", filters: [] },
  monitor: { delimiter: "monitor", filters: [] },
  system: { delimiter: "system", filters: [] },
  tags: { delimiter: "tags", filters: [] }
};
var commonProcessor = (searchParams) => {
  let params = new URLSearchParams(searchParams);
  const pageState = Object.entries(commonFields).reduce((accu, [key, { parse, select, target }]) => {
    const values = params.getAll(key);
    if (!values.length) {
      return accu;
    }
    if (!parse) {
      accu[target] = values;
    } else {
      try {
        accu[target] = select(values.map(parse));
      } catch (error) {
        console.log("encountered faulty url param, continue...", error);
      }
    }
    return accu;
  }, {});
  Object.keys(commonFields).map((key) => params.delete(key));
  const sort = params.has("sort") ? params.getAll("sort").reduce((sortAccu, scopedQuery) => {
    const items = scopedQuery.split(SEPARATOR).reverse();
    return ["direction", "key", "scope"].reduce((accu, key, index) => {
      if (items[index]) {
        accu[key] = items[index];
      }
      return accu;
    }, sortAccu);
  }, {}) : void 0;
  params.delete("sort");
  return { pageState, params, sort };
};
var legacyDeviceQueryParse = (searchParams, filteringAttributes) => {
  let params = new URLSearchParams(searchParams);
  const result = Object.keys(scopes).reduce((accu, scope) => ({ ...accu, [scope]: [] }), {});
  if (params.get("group")) {
    result.inventory.push({ ...import_constants.emptyFilter, key: "group", scope: "inventory", operator: import_constants.DEVICE_FILTERING_OPTIONS.$eq.key, value: params.get("group") });
    params.delete("group");
  }
  const filters = [...params.keys()].reduce(
    (accu, key) => params.getAll(key).reduce((innerAccu, value) => {
      const scope = Object.entries(filteringAttributes).reduce((foundScope, [currentScope, attributes]) => {
        if (foundScope) {
          return foundScope;
        }
        return attributes.includes(key) ? currentScope.substring(0, currentScope.indexOf("Attributes")) : foundScope;
      }, void 0) ?? import_constants.ATTRIBUTE_SCOPES.inventory;
      innerAccu[scope].push({ ...import_constants.emptyFilter, scope, key, operator: import_constants.DEVICE_FILTERING_OPTIONS.$eq.key, value });
      return innerAccu;
    }, accu),
    result
  );
  [...params.keys()].map((key) => params.delete(key));
  return { filters, params };
};
var scopedFilterParse = (searchParams) => {
  let params = new URLSearchParams(searchParams);
  const filters = Object.keys(scopes).reduce(
    (accu, scope) => {
      accu[scope] = [];
      if (!params.has(scope)) {
        return accu;
      }
      accu[scope] = params.getAll(scope).map((scopedQuery) => {
        const items = scopedQuery.split(SEPARATOR);
        return { ...import_constants.emptyFilter, scope, key: items[0], operator: `$${items[1]}`, value: items.slice(2).join(SEPARATOR) };
      });
      return accu;
    },
    { ...scopes }
  );
  Object.keys(scopes).map((scope) => params.delete(scope));
  return { filters, params };
};
var parseDeviceQuery = (searchParams, extraProps = {}) => {
  let queryParams = new URLSearchParams(searchParams);
  const { filteringAttributes = {}, pageState = {} } = extraProps;
  const pageStateExtension = pageState.id?.length === 1 ? { open: true } : {};
  let scopedFilters;
  const refersOldStyleAttributes = Object.values(filteringAttributes).some((scopeValues) => scopeValues.some((scopedValue) => queryParams.get(scopedValue)));
  if (refersOldStyleAttributes && !Object.keys(scopes).some((scope) => queryParams.get(scope)) || queryParams.get("group")) {
    const { filters, params } = legacyDeviceQueryParse(queryParams, filteringAttributes);
    scopedFilters = filters;
    queryParams = params;
  } else {
    const { filters, params } = scopedFilterParse(queryParams);
    scopedFilters = filters;
    queryParams = params;
  }
  let groupName = "";
  const groupFilterIndex = scopedFilters.inventory.findIndex((filter) => filter.key === "group" && filter.operator === import_constants.DEVICE_FILTERING_OPTIONS.$eq.key);
  if (groupFilterIndex > -1) {
    groupName = scopedFilters.inventory[groupFilterIndex].value;
    scopedFilters.inventory.splice(groupFilterIndex, 1);
  }
  const detailsTab = queryParams.has("tab") ? queryParams.get("tab") : "";
  return { detailsTab, filters: Object.values(scopedFilters).flat(), groupName, ...pageStateExtension };
};
var formatSorting = (sort, { sort: sortDefault }) => {
  if (!sort || deepCompare(sort, sortDefault)) {
    return "";
  }
  const sortQuery = ["scope", "key", "direction"].reduce((accu, key) => {
    if (!sort[key]) {
      return accu;
    }
    accu.push(sort[key]);
    return accu;
  }, []).join(SEPARATOR);
  return `sort=${sortQuery}`;
};
var formatPageState = ({ selectedId, selectedIssues, page, perPage, sort }, { defaults }) => Object.entries({ page, perPage, id: selectedId, issues: selectedIssues, open: selectedId ? true : void 0 }).reduce(
  (accu, [key, value]) => {
    if (Array.isArray(value)) {
      accu.push(...value.map((item) => `${key}=${encodeURIComponent(item)}`));
    } else if ((import_constants.DEVICE_LIST_DEFAULTS[key] != value || !import_constants.DEVICE_LIST_DEFAULTS.hasOwnProperty(key)) && value) {
      accu.push(`${key}=${encodeURIComponent(value)}`);
    }
    return accu;
  },
  [formatSorting(sort, defaults)]
).filter((i) => i).join("&");
var stripFilterOperator = (operator) => operator.replaceAll("$", "");
var formatFilters = (filters) => {
  const result = filters.reduce(
    (accu, filter) => {
      const { scope = import_constants.ATTRIBUTE_SCOPES.inventory, operator = "$eq" } = filter;
      accu[scope].add(`${scopes[scope].delimiter}=${filter.key}${SEPARATOR}${stripFilterOperator(operator)}${SEPARATOR}${encodeURIComponent(filter.value)}`);
      return accu;
    },
    Object.keys(scopes).reduce((accu, item) => ({ ...accu, [item]: /* @__PURE__ */ new Set() }), {})
  );
  return Object.values(result).map((filterSet) => [...filterSet]).flat();
};
var formatDeviceSearch = ({ pageState, filters, selectedGroup }) => {
  let activeFilters = [...filters];
  if (selectedGroup && selectedGroup !== import_constants.ALL_DEVICES) {
    const isUngroupedGroup = selectedGroup === import_constants.UNGROUPED_GROUP.id;
    activeFilters = isUngroupedGroup ? activeFilters.filter(
      (filter) => !(filter.key === "group" && filter.scope === import_constants.ATTRIBUTE_SCOPES.system && filter.operator === import_constants.DEVICE_FILTERING_OPTIONS.$nin.key)
    ) : activeFilters;
    const groupName = isUngroupedGroup ? import_constants.UNGROUPED_GROUP.name : selectedGroup;
    activeFilters.push({ scope: import_constants.ATTRIBUTE_SCOPES.inventory, key: "group", operator: import_constants.DEVICE_FILTERING_OPTIONS.$eq.key, value: groupName });
  }
  const formattedFilters = formatFilters(activeFilters).filter((i) => i);
  if (pageState.detailsTab && pageState.selectedId) {
    formattedFilters.push(`tab=${pageState.detailsTab}`);
  }
  return formattedFilters.join("&");
};
var generateDevicePath = ({ pageState }) => {
  const { state: selectedState } = pageState;
  const path = ["/devices"];
  if (selectedState !== "") {
    path.push(selectedState);
  }
  return path.join("/");
};
var formatDates = ({ endDate, params, startDate, today, tonight }) => {
  if (endDate && endDate !== tonight) {
    params.set("endDate", endDate.split("T")[0]);
  }
  if (startDate && startDate !== today) {
    params.set("startDate", startDate.split("T")[0]);
  }
  return params;
};
var paramReducer = (accu, [key, value]) => {
  if (value) {
    accu.set(key, value);
  }
  return accu;
};
var formatAuditlogs = ({ pageState }, { today, tonight }) => {
  const { detail, endDate, startDate, type, user } = pageState;
  let params = new URLSearchParams();
  let userId = user;
  if (user?.id) {
    userId = user.id;
  }
  params = Object.entries({ objectId: detail, userId }).reduce(paramReducer, params);
  if (type) {
    params.set("objectType", type.value ?? type);
  }
  params = formatDates({ endDate, params, startDate, today, tonight });
  return params.toString();
};
var parseDateParams = (params, today, tonight) => {
  let endDate = tonight;
  if (params.get("endDate")) {
    endDate = getISOStringBoundaries(new Date(params.get("endDate"))).end;
  }
  let startDate = today;
  if (params.get("startDate")) {
    startDate = getISOStringBoundaries(new Date(params.get("startDate"))).start;
  }
  return { endDate, startDate };
};
var parseAuditlogsQuery = (params, { today, tonight }) => {
  const type = import_constants.AUDIT_LOGS_TYPES.find((typeObject) => typeObject.value === params.get("objectType"));
  const { endDate, startDate } = parseDateParams(params, today, tonight);
  return {
    detail: params.get("objectId"),
    endDate,
    startDate,
    type,
    user: params.get("userId")
  };
};
var formatActiveDeployments = (pageState, { defaults }) => [import_constants.DEPLOYMENT_STATES.inprogress, import_constants.DEPLOYMENT_STATES.pending].reduce((accu, state) => {
  const { page, perPage } = pageState[state] ?? {};
  const stateDefaults = defaults[state] ?? {};
  const items = Object.entries({ page, perPage }).reverse().reduce((keyAccu, [key, value]) => {
    if (value && value !== stateDefaults[key] || keyAccu.length) {
      keyAccu.unshift(value || stateDefaults[key]);
    }
    return keyAccu;
  }, []);
  if (items.length) {
    accu.push(`${state}=${items.join(SEPARATOR)}`);
  }
  return accu;
}, []).filter((i) => i).join("&");
var formatDeployments = ({ deploymentObject, pageState }, { defaults, today, tonight }) => {
  const { state: selectedState, showCreationDialog } = pageState.general;
  let params = new URLSearchParams();
  if (showCreationDialog) {
    params.set("open", true);
    if (deploymentObject.release) {
      params.set("release", deploymentObject.release.name);
    }
    if (deploymentObject.devices?.length) {
      deploymentObject.devices.map(({ id }) => params.append("deviceId", id));
    }
  }
  let pageStateQuery;
  if (selectedState === import_constants.DEPLOYMENT_ROUTES.finished.key) {
    const { endDate, search, startDate, type } = pageState[selectedState];
    params = formatDates({ endDate, params, startDate, today, tonight });
    params = Object.entries({ search, type }).reduce(paramReducer, params);
    pageStateQuery = formatPageState(pageState[selectedState], { defaults });
  } else if (selectedState === import_constants.DEPLOYMENT_ROUTES.scheduled.key) {
    pageStateQuery = formatPageState(pageState[selectedState], { defaults });
  } else {
    pageStateQuery = formatActiveDeployments(pageState, { defaults });
  }
  return [pageStateQuery, params.toString()].filter((i) => i).join("&");
};
var deploymentsPath = "deployments/";
var parseDeploymentsPath = (path) => {
  const parts = path.split(deploymentsPath);
  if (parts.length > 1 && Object.keys(import_constants.DEPLOYMENT_ROUTES).includes(parts[1])) {
    return parts[1];
  }
  return "";
};
var parseActiveDeployments = (params) => [import_constants.DEPLOYMENT_STATES.inprogress, import_constants.DEPLOYMENT_STATES.pending].reduce((accu, state) => {
  if (!params.has(state)) {
    return accu;
  }
  const items = params.get(state).split(SEPARATOR);
  accu[state] = ["page", "perPage"].reduce((stateAccu, key, index) => items[index] ? { ...stateAccu, [key]: Number(items[index]) } : stateAccu, {});
  return accu;
}, {});
var deploymentFields = {
  deviceId: { attribute: "devices", parse: (id) => ({ id }), select: (i) => i },
  release: { attribute: "release", parse: String, select: defaultSelector }
};
var parseDeploymentsQuery = (params, { pageState, location, tonight }) => {
  const { endDate, startDate } = parseDateParams(params, "", tonight);
  const deploymentObject = Object.entries(deploymentFields).reduce(
    (accu, [key, { attribute, parse, select }]) => params.has(key) ? { ...accu, [attribute]: select(params.getAll(key).map(parse)) } : accu,
    {}
  );
  const { state: selectedState, id, open, ...remainingPageState } = pageState;
  const tab = parseDeploymentsPath(location.pathname);
  const deploymentsTab = tab || selectedState || import_constants.DEPLOYMENT_ROUTES.active.key;
  let state = {
    deploymentObject,
    general: {
      showCreationDialog: Boolean(open && !id),
      showReportDialog: Boolean(open && id),
      state: deploymentsTab
    }
  };
  if (deploymentsTab === import_constants.DEPLOYMENT_ROUTES.finished.key) {
    const type = import_constants.DEPLOYMENT_TYPES[params.get("type")] || "";
    const search = params.get("search") || "";
    state[deploymentsTab] = { ...remainingPageState, endDate, search, startDate, type };
  } else if (deploymentsTab === import_constants.DEPLOYMENT_ROUTES.scheduled.key) {
    state[deploymentsTab] = { ...remainingPageState };
  } else {
    state = {
      ...state,
      ...parseActiveDeployments(params)
    };
  }
  return state;
};
var generateDeploymentsPath = ({ pageState }) => {
  const { state: selectedState = import_constants.DEPLOYMENT_ROUTES.active.key } = pageState.general;
  return `/deployments/${selectedState}`;
};
var releasesRoot = "/releases";
var formatReleases = ({ pageState: { searchTerm, selectedTags = [], tab, type } }) => Object.entries({ name: searchTerm, tab, type }).reduce(
  (accu, [key, value]) => value ? [...accu, `${key}=${value}`] : accu,
  selectedTags.map((tag) => `tag=${tag}`)
).join("&");
var generateReleasesPath = ({ pageState: { selectedRelease } }) => `${releasesRoot}${selectedRelease ? `/${encodeURIComponent(selectedRelease)}` : ""}`;
var parseReleasesQuery = (queryParams, extraProps) => {
  const name = queryParams.has("name") ? queryParams.get("name") : "";
  const tab = queryParams.has("tab") ? queryParams.get("tab") : void 0;
  const tags = queryParams.has("tag") ? queryParams.getAll("tag") : [];
  const type = queryParams.has("type") ? queryParams.get("type") : "";
  let selectedRelease = decodeURIComponent(extraProps.location.pathname.substring(releasesRoot.length + 1));
  if (!selectedRelease && extraProps.pageState.id?.length) {
    selectedRelease = extraProps.pageState.id[0];
  }
  return { searchTerm: name, selectedRelease, tab, tags, type };
};
var tenantsRoot = "/tenants";
var generateTenantPath = ({ pageState: { selectedTenant } }) => {
  if (selectedTenant) {
    return `${tenantsRoot}/${encodeURIComponent(selectedTenant)}`;
  } else {
    return tenantsRoot;
  }
};
var generateTenantPathById = (id) => id ? `${tenantsRoot}/${encodeURIComponent(id)}` : tenantsRoot;
var parseTenantsQuery = (queryParams, extraProps) => {
  const name = queryParams.has("name") ? queryParams.get("name") : "";
  let selectedTenant = extraProps.location.pathname.substring(tenantsRoot.length + 1);
  if (!selectedTenant && extraProps.pageState.id?.length) {
    selectedTenant = extraProps.pageState.id[0];
  }
  return { name, selectedTenant };
};
var formatTenants = () => "";

// src/liststatehook.js
var defaultProcessors = {
  auditlogs: {
    format: formatAuditlogs,
    locate: () => void 0,
    parse: parseAuditlogsQuery
  },
  common: {
    format: formatPageState,
    locate: () => void 0,
    parse: commonProcessor
  },
  deployments: {
    format: formatDeployments,
    locate: generateDeploymentsPath,
    parse: parseDeploymentsQuery
  },
  devices: {
    format: formatDeviceSearch,
    locate: generateDevicePath,
    parse: parseDeviceQuery
  },
  releases: {
    format: formatReleases,
    locate: generateReleasesPath,
    parse: parseReleasesQuery
  },
  tenants: {
    format: formatTenants,
    locate: generateTenantPath,
    parse: parseTenantsQuery
  }
};
var useLocationParams = (key, extras, processors = defaultProcessors) => {
  let [searchParams] = (0, import_react_router_dom.useSearchParams)();
  const navigate = (0, import_react_router_dom.useNavigate)();
  const location = (0, import_react_router_dom.useLocation)();
  let value = (0, import_react2.useMemo)(() => {
    const { pageState, params, sort } = processors.common.parse(searchParams);
    const extendedExtras = { ...extras, pageState, location };
    return {
      ...pageState,
      sort,
      ...processors[key].parse(params, extendedExtras)
    };
  }, [JSON.stringify(extras), key, location.search, location.pathname, searchParams.toString()]);
  let setValue = (0, import_react2.useCallback)(
    (newValue, options = {}) => {
      const pathname = processors[key].locate({ pageState: newValue.pageState, location });
      const searchQuery = [processors.common.format(newValue.pageState, extras), processors[key].format(newValue, extras)].filter((i) => i).join("&");
      navigate({ pathname, replace: true, search: `?${searchQuery}`, ...options });
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [JSON.stringify(extras), key]
  );
  return [value, setValue];
};

// src/resizehook.js
var import_react3 = require("react");
var import_constants2 = require("@northern.tech/store/constants");
var useWindowSize = () => {
  const [size, setSize] = (0, import_react3.useState)({ height: window.innerHeight, width: window.innerWidth });
  const timer = (0, import_react3.useRef)();
  (0, import_react3.useLayoutEffect)(() => {
    const handleResize = () => {
      timer.current = setTimeout(() => setSize({ height: window.innerHeight, width: window.innerWidth }), import_constants2.TIMEOUTS.halfASecond);
    };
    window.addEventListener("resize", handleResize);
    handleResize();
    return () => {
      clearTimeout(timer.current);
      window.removeEventListener("resize", handleResize);
    };
  }, []);
  return size;
};

// src/retrytimer.js
var import_constants3 = require("@northern.tech/store/constants");
var timers = {};
function setRetryTimer(err, service, errorContext, timeLeft, setSnackbar) {
  if (timers[service]) {
    return;
  }
  let remaining = timeLeft - import_constants3.TIMEOUTS.oneSecond;
  timers[service] = setInterval(() => {
    remaining -= import_constants3.TIMEOUTS.oneSecond;
    const errMsg = extractErrorMessage(err, "Please check your connection.");
    remaining > 0 ? setSnackbar(preformatWithRequestID(err.response, `${errorContext} ${errMsg} Retrying in ${remaining / 1e3} seconds`)) : clearRetryTimer(service, setSnackbar);
  }, import_constants3.TIMEOUTS.oneSecond);
}
function clearRetryTimer(service, setSnackbar) {
  if (timers[service]) {
    clearInterval(timers[service]);
    delete timers[service];
    setSnackbar("");
  }
}
function clearAllRetryTimers(setSnackbar) {
  Object.keys(timers).map((service) => clearRetryTimer(service, setSnackbar));
  setSnackbar("");
}

// src/sockethook.js
var import_react4 = require("react");
var import_constants4 = require("@northern.tech/store/constants");
var import_msgpack5 = __toESM(require("msgpack5"), 1);
var import_universal_cookie2 = __toESM(require("universal-cookie"), 1);
var cookies2 = new import_universal_cookie2.default();
var MessagePack = (0, import_msgpack5.default)();
var byteArrayToString = (body) => String.fromCharCode(...body);
var blobToString = (blob) => new Promise((resolve) => {
  let fr = new FileReader();
  fr.onload = () => {
    resolve(fr.result);
  };
  fr.readAsArrayBuffer(blob);
});
var useSession = ({ onClose, onHealthCheckFailed, onMessageReceived, onNotify, onOpen, token }) => {
  const [sessionId, setSessionId] = (0, import_react4.useState)();
  const healthcheckTimeout = (0, import_react4.useRef)();
  const socketRef = (0, import_react4.useRef)();
  const sendMessage = (0, import_react4.useCallback)(({ typ, body, props }) => {
    if (!socketRef.current) {
      return;
    }
    const proto_header = { proto: import_constants4.DEVICE_MESSAGE_PROTOCOLS.Shell, typ, sid: socketRef.current.sessionId, props };
    const encodedData = MessagePack.encode({ hdr: proto_header, body });
    socketRef.current.send(encodedData);
  }, []);
  const close = (0, import_react4.useCallback)(() => {
    if (!socketRef.current || socketRef.current?.readyState !== WebSocket.OPEN) {
      return;
    }
    sendMessage({ typ: import_constants4.DEVICE_MESSAGE_TYPES.Stop, body: {}, props: {} });
    socketRef.current.close();
    setSessionId();
  }, [sendMessage]);
  const healthcheckFailed = (0, import_react4.useCallback)(() => {
    onHealthCheckFailed();
    close();
  }, [close, onHealthCheckFailed]);
  const onSocketMessage = (0, import_react4.useCallback)(
    (event) => blobToString(event.data).then((data) => {
      const {
        hdr: { props = {}, proto, sid, typ },
        body
      } = MessagePack.decode(data);
      if (proto !== import_constants4.DEVICE_MESSAGE_PROTOCOLS.Shell) {
        return;
      }
      switch (typ) {
        case import_constants4.DEVICE_MESSAGE_TYPES.New: {
          if (props.status == WebSocket.CLOSING) {
            onNotify(`Error: ${byteArrayToString(body)}`);
            setSessionId();
            return close();
          } else {
            clearTimeout(healthcheckTimeout.current);
            healthcheckTimeout.current = setTimeout(healthcheckFailed, 65 * import_constants4.TIMEOUTS.oneSecond);
            socketRef.current.sessionId = sid;
            return setSessionId(sid);
          }
        }
        case import_constants4.DEVICE_MESSAGE_TYPES.Shell:
          return onMessageReceived(body);
        case import_constants4.DEVICE_MESSAGE_TYPES.Stop:
          return close();
        case import_constants4.DEVICE_MESSAGE_TYPES.Ping: {
          if (healthcheckTimeout.current) {
            clearTimeout(healthcheckTimeout.current);
          }
          sendMessage({ typ: import_constants4.DEVICE_MESSAGE_TYPES.Pong });
          const timeout = parseInt(props.timeout);
          if (timeout > 0) {
            healthcheckTimeout.current = setTimeout(healthcheckFailed, timeout * import_constants4.TIMEOUTS.oneSecond);
          }
          return;
        }
        default:
          break;
      }
    }),
    [close, healthcheckFailed, onMessageReceived, onNotify, sendMessage]
  );
  const onSocketError = (0, import_react4.useCallback)(
    (error) => {
      onNotify(`WebSocket error: ${error.message}`);
      close();
      clearTimeout(healthcheckTimeout.current);
    },
    [close, onNotify]
  );
  const onSocketOpen = (0, import_react4.useCallback)(() => {
    sendMessage({ typ: import_constants4.DEVICE_MESSAGE_TYPES.New, props: {} });
    onOpen(true);
  }, [onOpen, sendMessage]);
  const onSocketClose = (0, import_react4.useCallback)(
    (e) => {
      console.log("closing");
      onClose(e);
      close();
    },
    [close, onClose]
  );
  const connect = (0, import_react4.useCallback)(
    (deviceId) => {
      const uri = `wss://${window.location.host}${import_constants4.apiUrl.v1}/deviceconnect/devices/${deviceId}/connect`;
      setSessionId();
      cookies2.set("JWT", token, { path: "/", secure: true, sameSite: "strict", maxAge: 5 });
      try {
        socketRef.current = new WebSocket(uri);
      } catch (error) {
        console.log(error);
      }
    },
    [token]
  );
  (0, import_react4.useEffect)(() => {
    if (!socketRef.current) {
      return;
    }
    socketRef.current.addEventListener("close", onSocketClose);
    socketRef.current.addEventListener("error", onSocketError);
    socketRef.current.addEventListener("message", onSocketMessage);
    socketRef.current.addEventListener("open", onSocketOpen);
    return () => {
      socketRef.current.removeEventListener("close", onSocketClose);
      socketRef.current.removeEventListener("error", onSocketError);
      socketRef.current.removeEventListener("message", onSocketMessage);
      socketRef.current.removeEventListener("open", onSocketOpen);
    };
  }, [onSocketClose, onSocketError, onSocketMessage, onSocketOpen, socketRef.current?.readyState]);
  return [connect, sendMessage, close, socketRef.current?.readyState ?? WebSocket.CLOSED, sessionId];
};

// src/tracking.js
var import_react_ga4 = __toESM(require("react-ga4"), 1);
var cookieConsentCSS = "https://cdn.jsdelivr.net/npm/cookieconsent@3/build/cookieconsent.min.css";
var cookieConsentJS = "https://cdn.jsdelivr.net/npm/cookieconsent@3/build/cookieconsent.min.js";
var ReactGA = import_react_ga4.default.default;
var Tracker = class {
  constructor() {
    this.initialized = false;
    this.trackingEnabled = true;
    this.currentPageView = null;
    this.currentOrganizationUser = null;
  }
  cookieconsent() {
    return new Promise((resolve) => {
      const style = document.createElement("link");
      style.href = cookieConsentCSS;
      style.rel = "stylesheet";
      style.async = true;
      document.head.appendChild(style);
      const script = document.createElement("script");
      script.src = cookieConsentJS;
      script.async = false;
      script.addEventListener("load", () => {
        window.cookieconsent.initialise({
          palette: {
            popup: {
              background: "#5d0f43",
              text: "#ffffff"
            },
            button: {
              background: "#73a4ad",
              text: "#ffffff"
            }
          },
          position: "bottom-left",
          type: "opt-out",
          content: {
            message: "We use cookies to analyze our traffic so we can improve our website and give you a better experience.",
            link: "View our cookie policy",
            href: "https://northern.tech/legal/cookies"
          },
          autoOpen: true,
          revokable: false,
          law: {
            regionalLaw: false
          },
          onStatusChange: (status) => {
            let hasConsented = status == "allow";
            resolve({ trackingConsentGiven: hasConsented });
          }
        });
      });
      document.body.appendChild(script);
    });
  }
  exception(error) {
    if (this.initialized && this.trackingEnabled) {
      ReactGA.event("error", error);
    }
  }
  event(data) {
    if (this.initialized && this.trackingEnabled) {
      ReactGA.event(data);
    }
  }
  initialize(trackingCode) {
    if (this.initialized && this.trackingEnabled) {
      return false;
    }
    ReactGA.initialize(trackingCode);
    this.initialized = true;
    return true;
  }
  pageview(data) {
    if (data) {
      this.currentPageView = data;
    }
  }
  set(value) {
    if (this.initialized && this.trackingEnabled) {
      ReactGA.set(value);
    }
  }
  setOrganizationUser(organization, user) {
    if (this.initialized && this.trackingEnabled && this.currentOrganizationUser != { organization, user }) {
      this.currentOrganizationUser = { organization, user };
      this.set({ dimension1: organization.plan });
      this.set({ dimension2: organization.id });
      this.set({ dimension3: user.id });
      this.set({ userId: user.id });
    }
  }
  setTrackingEnabled(trackingEnabled) {
    this.trackingEnabled = trackingEnabled;
  }
};
var Tracking = new Tracker();
var tracking_default = Tracking;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Tracking,
  attributeDuplicateFilter,
  blobToString,
  byteArrayToString,
  canAccess,
  clearAllRetryTimers,
  clearRetryTimer,
  commonProcessor,
  createDownload,
  createFileDownload,
  customSort,
  dateRangeToUnix,
  deepCompare,
  defaultProcessors,
  detectOsIdentifier,
  duplicateFilter,
  extractErrorMessage,
  extractSoftware,
  extractSoftwareItem,
  formatAuditlogs,
  formatDeployments,
  formatDeviceSearch,
  formatPageState,
  formatReleases,
  formatTenants,
  formatTime,
  fullyDecodeURI,
  generateDeploymentsPath,
  generateDevicePath,
  generateReleasesPath,
  generateTenantPath,
  generateTenantPathById,
  getDebConfigurationCode,
  getDemoDeviceAddress,
  getFormattedSize,
  getISOStringBoundaries,
  getPhaseDeviceCount,
  getRemainderPercent,
  getSnackbarMessage,
  isEmpty,
  parseAuditlogsQuery,
  parseDateParams,
  parseDeploymentsQuery,
  parseDeviceQuery,
  parseReleasesQuery,
  parseTenantsQuery,
  preformatWithRequestID,
  setRetryTimer,
  standardizePhases,
  startTimeSort,
  stringToBoolean,
  toggle,
  unionizeStrings,
  useDebounce,
  useLocationParams,
  useSession,
  useWindowSize,
  validatePhases,
  versionCompare,
  yes
});
//# sourceMappingURL=index.cjs.map